image: registry.gitlab.com/dreamer-labs/repoman/dl-ubuntu-docker:latest
services:
  - docker:18.09.8-dind

stages:
  - functional

variables:
  DOCKER_TLS_CERTDIR: "/certs"
  DOCKER_TLS_ENABLE: "true"
  DOCKER_HOST: "tcp://docker:2376"
  TYPE: "functional"


functional:
  before_script:
    - echo $PIPERCI_INSTALLER_REPO
    - echo $PIPERCI_INSTALLER_VERSION
    - pip3 install ansible
    - git clone --recursive "${PIPERCI_INSTALLER_REPO:=https://gitlab.com/dreamer-labs/piperci/piperci-installer}"
    - cd piperci-installer
    - git fetch --all
    - git checkout "${PIPERCI_INSTALLER_VERSION:=master}"
  stage: functional
  script: |
    export DOCKER_HOST='tcp://docker:2376'
    cd dev
    ansible-playbook -i "localhost," ansible_dind.yml --tags=install \
      -e "ansible_connection=local" \
      -e "pi_install_piperci_faas_gateway=172.17.0.3:8080" \
      -e "read_releases_url=${READ_RELEASES_URL:-https://gitlab.com/dreamer-labs/piperci/piperci-releases}" \
      -e "read_releases_version=${READ_RELEASES_VERSION:-master}"
    sleep 90
    docker ps --all
    docker network ls
    gman_name=$(docker ps --format "{{.Names}}" | grep gman)
    minio_name=$(docker ps --format "{{.Names}}" | grep minio)
    #registry.gitlab.com/dreamer-labs/piperci/piperci-picli:latest \
    docker run \
      --link "${gman_name}":gman \
      --link "${minio_name}":minio \
      --net func_functions \
     "${picli_uri:-registry.gitlab.com/dreamer-labs/piperci/piperci-picli}:${picli_version:-latest}" \
      sh -c "\
        git clone https://gitlab.com/dreamer-labs/piperci/piperci-demo \
          && cd piperci-demo \
          && echo -e 'project_name: \"python_project\"\nversion: \"0.0.0\"\ngman_url: \"http://gman:8080\"\nfaas_endpoint: \"http://172.17.0.3:8080\"\nstorage:\n  type: \"minio\"\n  hostname: \"minio:9000\"\n  access_key: \"test\"\n  secret_key: \"test_secret\"' > piperci.d/default/config.yml \
          && picli --debug run \
      "
  only:
    variables:
      - $TYPE == "functional"
